/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.statistik.boundary;

import de.ivu.elect.business.statistik.entity.StatistikLauf;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class StatistikLaufDAO extends AbstractStatistikLaufDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(StatistikLauf statistikLauf){
    getEntityManager().persist(statistikLauf);
  }

  public void remove(StatistikLauf statistikLauf){
    getEntityManager().remove(statistikLauf);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                    
        /**
        * Name: StatusNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM StatistikLauf o WHERE o.status = ?1 ORDER by o.zeitpunktDesLaufs ASC<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<StatistikLauf> findByStatus( @javax.annotation.Nonnull de.ivu.elect.business.statistik.entity.StatistikLaufStatus status,  int limit) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("StatistikLauf.findByStatus" ,  status  ,  limit);

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByStatus( status  ,  limit));
        }
        return (java.util.List<StatistikLauf>) cached;
        }
            return super.findByStatus( status  ,  limit);
            }
                                            
        /**
        * Name: WahlterminNichtWahlAusloeserNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM StatistikLauf o WHERE o.wahltermin=?1 AND o.wahl IS NULL AND o.ausloeser=?2<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<StatistikLauf> findByWahlterminNichtWahlAusloeser( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull String ausloeser) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("StatistikLauf.findByWahlterminNichtWahlAusloeser" ,  wahltermin ,  ausloeser  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlterminNichtWahlAusloeser( wahltermin ,  ausloeser  ));
        }
        return (java.util.List<StatistikLauf>) cached;
        }
            return super.findByWahlterminNichtWahlAusloeser( wahltermin ,  ausloeser  );
            }
                        
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}